SystemOrganization addCategory: #PTExtensions!

!String methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:51'!
asAliasedElement

	^ PTElement new
		alias: self;
		yourself! !

!String methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:57'!
asPTElement

	^ self asJSObject asPTElement! !

!String methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:28'!
asPTEvent
	^ PTEvent new alias: self! !

!String methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:00'!
asPTFormElement

	^ self 
		asPTElement
		asPTFormElement! !

!String methodsFor: '*ptextensions' stamp: 'sebastian.sastre 2/1/2010 11:33'!
asPTObject

	^ PTObject new alias: self! !

!PTAjax methodsFor: '*ptextensions' stamp: 'sebastian.sastre 3/18/2011 10:60'!
fullUrl
	"Answer a Seaside URL object that is composed with the parameters of the receiver. This method excludes dynamic Javascript objects that might be part of the parameters."
	
	| anUrl |
	anUrl := self url copy.
	self parameters do: [ :each | 
		(each isString)
			ifTrue: [ anUrl addField: each ].
		(each isVariableBinding and: [ each value isJavascript not ])
			ifTrue: [ anUrl addField: each key value: each value ] ].
	^ anUrl! !

!PTAjax methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:39'!
on: anEventKey add: anObject
	"Adds aScript to the receiver (re)actions 
	meant to happen when anEventKey."

	| key |
	key := 'on',anEventKey asString capitalized.
	^ self 
		optionAt: key
		put: (self optionAt: key ifAbsentPut:[JSScript new asFunction]) , anObject  asFunction
	! !

!PTAjax methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:38'!
onExpiry: anObject

	self onStatus: 403 do: anObject ! !

JSStatement subclass: #PTExtend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PTExtensions'!

!PTExtend methodsFor: 'public' stamp: 'sebastian.sastre 1/17/2010 20:26'!
javascriptContentOn: aStream
	
	aStream nextPutAll: '$('.
	super javascriptContentOn: aStream.
	aStream nextPutAll: ')'
	! !

JSStatement subclass: #PTSplit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PTExtensions'!

!PTSplit methodsFor: 'public' stamp: 'sebastian.sastre 1/17/2010 20:25'!
javascriptContentOn: aStream
	
	aStream nextPutAll: '$w('.
	super javascriptContentOn: aStream.
	aStream nextPutAll: ')'
	! !

!PTFormElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:23'!
disable
	"Disables a form control, effectively preventing its value to be changed until it is enabled again."

	self assign: true as: 'disabled'
! !

!PTFormElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:22'!
enable
	"Enables a previously disabled form control."

	self assign: false as: 'disabled'
! !

!PTFormElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 1/25/2010 11:57'!
value: anObject
	"Sets to anObject the current value 
	of the form control accessed by the receiver."

	self call: 'setValue' with: anObject 
		
"	^ (self access: 'value') assign: anObject "! !

!PTEnumerable methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:38'!
do: anObject in: aContext
	self 
		call: 'each'
		with: (self 
				iteratorFor: anObject
				return: false)
		with: aContext! !

!PTEnumerable methodsFor: '*ptextensions' stamp: 'sebastian.sastre 1/25/2010 11:51'!
each: anInteger slice: anIterator
	"Groups items in chunks based on a given size, with last chunk being possibly smaller."
	
	self call: 'eachSlice' withArguments: (Array with: anInteger with: anIterator)
! !

!PTEnumerable methodsFor: '*ptextensions' stamp: 'sebastian.sastre 1/25/2010 11:57'!
eachSlice: anInteger
	"Groups items in chunks based on a given size, with last chunk being possibly smaller."
	
	self call: 'eachSlice' with: anInteger 
! !

!PTEnumerable methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:39'!
first

	^ self call: 'first'! !

!PTEnumerable methodsFor: '*ptextensions' stamp: 'sebastian.sastre 1/25/2010 11:51'!
inject: anAccumulator into: anIteratorFunction

	self call: 'inject' withArguments: (Array with: anAccumulator with: anIteratorFunction)! !

!PTEnumerable methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:39'!
iteratorFor: anObject return: aBoolean
	^ (anObject isKindOf: BlockClosure)
		ifFalse: [ anObject asFunction ]
		ifTrue: [ (JSFunction on: self canvas iterator: anObject) return: aBoolean ]! !

!PTEnumerable methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:39'!
last

	self call: 'last'! !

!PTEnumerable methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:39'!
reverse

	self call: 'reverse'! !

!PTEnumerable methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:39'!
toArray

	self call: 'toArray'! !

!JSObject class methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:25'!
alias: aName

	^ self new
		alias: aName;
		yourself! !

!JSObject methodsFor: '*ptextensions' stamp: 'sebastian.sastre 3/27/2010 16:00'!
asPTArray

	^ PTArray 
		on: self renderContext 
		receiver: self		! !

!JSObject methodsFor: '*ptextensions' stamp: 'sebastian.sastre 9/28/2009 05:55'!
asPTDollarA
	^ PTDollarA 
		context: self renderContext 
		receiver: self! !

!JSObject methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:16'!
asPTElement

	^ PTElement new
		id: self;
		yourself! !

!JSObject methodsFor: '*ptextensions' stamp: 'sebastian.sastre 8/5/2009 15:28'!
asPTForm
	^ PTForm new
		id: self;
		yourself! !

!JSObject methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:17'!
asPTFormElement

	^ PTFormElement new
		id: self;
		yourself! !

!JSObject methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:54'!
extend

	self call: 'extend'! !

!JSObject methodsFor: '*ptextensions' stamp: 'sebastian.sastre 1/17/2010 20:29'!
split

	self addDecoration: PTSplit new! !

!PTEvent methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:31'!
element
	"Returns the DOM element on which the event occurred."

	^ (self call: 'element') asPTElement 
	! !

!PTEvent methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:31'!
keyBackspace

	self access: 'KEY_BACKSPACE'! !

!PTEvent methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:31'!
keyCode

	self access: 'keyCode'! !

!PTEvent methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:31'!
keyDelete

	self access: 'KEY_DEL'! !

!PTEvent methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:31'!
keyDown

	self access: 'KEY_DOWN'! !

!PTEvent methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:31'!
keyEnter

	^ self keyReturn
! !

!PTEvent methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:31'!
keyEsc

	self access: 'KEY_ESC'! !

!PTEvent methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:31'!
keyLeft

	self access: 'KEY_LEFT'! !

!PTEvent methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:31'!
keyPageDown

	self access: 'KEY_PAGEDOWN'! !

!PTEvent methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:31'!
keyPageUp

	self access: 'KEY_PAGEUP'! !

!PTEvent methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:31'!
keyReturn

	self access: 'KEY_RETURN'! !

!PTEvent methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:31'!
keyRight

	self access: 'KEY_RIGHT'! !

!PTEvent methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:31'!
keyTab

	self access: 'KEY_TAB'! !

!PTEvent methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 19:31'!
keyUp

	self access: 'KEY_UP'! !

!PTEvent methodsFor: '*ptextensions' stamp: 'SebastianSastre 1/17/2012 15:54'!
observe: anObservedObject on: anEventString do: aHandlerObject 
	"Define event handler aHandlerObject for anEventString."
	self 
		call: 'observe'
		withArguments: (Array 
				with: anObservedObject
				with: anEventString asString
				with: (aHandlerObject asFunction: #('event' )))! !

!PTEvent methodsFor: '*ptextensions' stamp: 'sebastian.sastre 1/25/2010 11:57'!
relatedElement: anObject

	self call: 'relatedElement' with: anObject ! !

!PTEvent methodsFor: '*ptextensions' stamp: 'sebastian.sastre 1/25/2010 11:59'!
stop
	"Stops the event's propagation and prevents its default action from being triggered eventually."

	^ PTEvent new
		call: 'stop' with: self;
		yourself! !

!PTEvent methodsFor: '*ptextensions' stamp: 'sebastian.sastre 1/25/2010 11:51'!
stopObserving: anElement on: anEvent with: aHandler
	"Unregister the handler for the event on the element. 
	Note that aHandler must be the exact same instance which 
	registered the event to unregister properly."

	^ PTEvent new
		call: 'stopObserving' 
		withArguments: (Array
						with: anElement 
						with: anEvent 
						with: aHandler);
		yourself! !

JSScript subclass: #PTPeriodicalUpdater
	instanceVariableNames: 'decay period updater'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PTExtensions'!

!PTPeriodicalUpdater methodsFor: 'options' stamp: 'sas 11/1/2008 18:56'!
asynchronous: aBoolean
	"Determines whether XMLHttpRequest is used asynchronously or not. Since synchronous usage is rather unsettling, and usually bad taste, you should avoid changing this. Seriously."

	self updater asynchronous: aBoolean! !

!PTPeriodicalUpdater methodsFor: 'callbacks' stamp: 'sas 11/1/2008 18:53'!
callback: aBlock
	"Register aBlock as a primary callback of the receiver. It only makes sense to have a single primary callback registered per instance. Depending on the actual evaluation strategy, see #handle:on:, aBlock will be evaluated with a renderer/script as its first argument."

	self updater callback: aBlock! !

!PTPeriodicalUpdater methodsFor: 'callbacks' stamp: 'sas 11/1/2008 18:54'!
callback: aBlock value: anObject
	"Register aBlock as a secondary callback. anObject is interpreted as JavaScript on the client-side, the result will be sent back to the server and passed into aBlock. Multiple secondary callbacks can be defined with one receiver."

	self updater callback: aBlock value: anObject
! !

!PTPeriodicalUpdater methodsFor: 'options' stamp: 'sas 11/1/2008 18:56'!
contentType: aString
	"The Content-Type header for your request. You might want to send XML instead of the regular URL-encoded format, in which case you would have to change this."


	self updater contentType: aString
! !

!PTPeriodicalUpdater methodsFor: 'accessing' stamp: 'sas 1/26/2009 12:19'!
decay
	^decay ifNil: [self initializeDecay]! !

!PTPeriodicalUpdater methodsFor: 'accessing' stamp: 'sas 1/26/2009 12:19'!
decay: anObject
	decay := anObject! !

!PTPeriodicalUpdater methodsFor: 'options' stamp: 'sas 11/1/2008 18:56'!
encoding: aString
	"The encoding for your request contents. It is best left as is, but should weird encoding issues arise, you may have to tweak it in accordance with other encoding-related parts of your page code and server side."

	self updater encoding: aString
! !

!PTPeriodicalUpdater methodsFor: 'options' stamp: 'sas 11/1/2008 19:06'!
evalScripts: aBoolean
	"This determines whether <script> elements in the response text are evaluated or not. The default implementation of Prototypes does not evaluate script, however this implementation changes this odd behavior."

	self updater evalScripts: aBoolean! !

!PTPeriodicalUpdater methodsFor: 'accessing' stamp: 'sebastian.sastre 4/5/2009 13:50'!
id: anId	self updater id: anId.
	statements do:[:s| s id: anId].

	statements first decoration object statements last id: anId.
	"statements last decoration object decoration owner owner owner id: anId"! !

!PTPeriodicalUpdater methodsFor: 'initializing' stamp: 'sebastian.sastre 7/20/2009 18:52'!
initialize
	
	super initialize.

	self 
		add: ((PTElement new 
				id: self updater id;
				yourself) 
					assign: (JSFunction new 
							add: self updater;
							yourself) as: 'basicUpdate');
		add: (PTElement new 
				id: self updater id;
				call: 'basicUpdate';
				yourself);
		"add: ((SUElement new 
				id: self updater id;
				yourself) assign: ((SUElement new 
								id: self updater id;
								call: 'basicUpdate';
								yourself) interval: self period) as: 'periodical');"
		yourself! !

!PTPeriodicalUpdater methodsFor: 'initializing' stamp: 'sas 1/26/2009 12:20'!
initializeDecay
	^decay := 1.3! !

!PTPeriodicalUpdater methodsFor: 'initializing' stamp: 'sas 1/26/2009 12:12'!
initializePeriod
	^period := 1! !

!PTPeriodicalUpdater methodsFor: 'initializing' stamp: 'sebastian.sastre 7/29/2009 11:35'!
initializeUpdater
	^updater := PTUpdater new! !

!PTPeriodicalUpdater methodsFor: 'options' stamp: 'sas 11/1/2008 18:56'!
method: aString
	"The HTTP method to use for the request. The other widespread possibility is 'get'."

	self updater method: aString
! !

!PTPeriodicalUpdater methodsFor: 'options' stamp: 'sas 11/1/2008 18:57'!
on: anEventKey add: anObject
	"Adds aScript to the receiver (re)actions 
	meant to happen when anEventKey."

	self updater on: anEventKey add: anObject
	! !

!PTPeriodicalUpdater methodsFor: 'options' stamp: 'sas 11/1/2008 18:57'!
on: aSelector of: anObject

	self updater on: aSelector of: anObject! !

!PTPeriodicalUpdater methodsFor: 'options' stamp: 'sas 11/1/2008 18:57'!
on: aSelector of: anObject value: anotherObject	self updater on: aSelector of: anObject value: anotherObject! !

!PTPeriodicalUpdater methodsFor: 'events' stamp: 'sas 1/26/2009 11:15'!
onComplete: aFunction
	"Triggered at the very end of a request's life-cycle, once the request completed, status-specific callbacks were called, and possible automatic behaviors were processed."

	self updater onComplete: (self updaterCompletedOn: aFunction)
! !

!PTPeriodicalUpdater methodsFor: 'events' stamp: 'sas 11/1/2008 18:58'!
onException: anObject
	"Triggered whenever an XHR error arises. Has a custom signature: the first argument is the requester, the second is the exception object."

	self updater onException: anObject! !

!PTPeriodicalUpdater methodsFor: 'events' stamp: 'sas 11/1/2008 18:58'!
onExpiry: anObject

	self updater onExpiry: anObject! !

!PTPeriodicalUpdater methodsFor: 'events' stamp: 'sas 11/1/2008 18:59'!
onFailure: anObject
	"Invoked when a request completes and its status code exists but is not in the 2xy family. This is skipped if a code-specific callback is defined, and happens before onComplete."

	self updater onFailure: anObject! !

!PTPeriodicalUpdater methodsFor: 'events' stamp: 'sas 11/1/2008 18:59'!
onInteractive: anObject
	"(Not guaranteed) Triggered whenever the requester receives a part of the response (but not the final part), should it be sent in several packets."

	self updater onInteractive: anObject! !

!PTPeriodicalUpdater methodsFor: 'events' stamp: 'sas 11/1/2008 18:59'!
onLoaded: anObject
	"(Not guaranteed) Triggered once the underlying XHR object is setup, the connection open, and ready to send its actual request."

	self updater onLoaded: anObject! !

!PTPeriodicalUpdater methodsFor: 'events' stamp: 'sas 11/1/2008 18:59'!
onLoading: anObject
	"(Not guaranteed) Triggered when the underlying XHR object is being setup, and its connection opened."

	self updater onLoading: anObject! !

!PTPeriodicalUpdater methodsFor: 'events' stamp: 'sas 11/1/2008 19:00'!
onStatus: anInteger do: anObject
	"With anInteger being an HTTP status code for the response. Invoked when the response just completed, and the status code is exactly the one we used in the callback name. Prevents execution of onSuccess / onFailure. Happens before onComplete."

	self updater onStatus: anInteger do: anObject! !

!PTPeriodicalUpdater methodsFor: 'events' stamp: 'sas 11/1/2008 19:00'!
onSuccess: anObject
	"Invoked when a request completes and its status code is undefined or belongs in the 2xy family. This is skipped if a code-specific callback is defined, and happens before onComplete."

	self updater onSuccess: anObject ! !

!PTPeriodicalUpdater methodsFor: 'events' stamp: 'sas 11/1/2008 19:00'!
onUninitialized: anObject
	"(Not guaranteed) Invoked when the XHR object was just created."

	self updater onUninitialized: anObject! !

!PTPeriodicalUpdater methodsFor: 'accessing' stamp: 'sas 1/26/2009 11:19'!
period
	^period ifNil: [self initializePeriod]! !

!PTPeriodicalUpdater methodsFor: 'accessing' stamp: 'sas 1/26/2009 12:11'!
period: anObject
	period := anObject.

! !

!PTPeriodicalUpdater methodsFor: 'categorize me' stamp: 'sas 11/1/2008 23:04'!
setCanvas: aCanvas

	self updater setCanvas: aCanvas! !

!PTPeriodicalUpdater methodsFor: 'accessing' stamp: 'sas 11/1/2008 18:55'!
updater
	^updater ifNil:[self initializeUpdater]! !

!PTPeriodicalUpdater methodsFor: 'accessing' stamp: 'sas 11/1/2008 18:54'!
updater: anObject
	updater := anObject! !

!PTPeriodicalUpdater methodsFor: 'events' stamp: 'sebastian.sastre 1/25/2010 11:58'!
updaterCompletedOn: aFunction 
	^ aFunction
		add: ('this.delay' asPTEvent isNull then: (self period asJSObject * 1000 assignTo: 'this.delay'));
		add: (('aResponse.responseText' asJSObject isNotEqualTo: 'this.lastText' asJSObject) 
				then: ('this.delay' asJSObject * self decay assignTo: 'this.delay')
				else: (self period asJSObject * 1000 assignTo: 'this.delay'));
		add: ('aResponse.responseText' asJSObject assignTo: 'this.lastText');
		add: ('window.periodicals' asJSObject isNull then: ((JSHash new
					at: self updater id
						put: nil;
					yourself) assignTo: 'window.periodicals' asJSObject));
		add: (('window.periodicals' asJSObject property: self updater id) notNull then: ('window' asJSObject 
					call: 'clearTimeout'
					with: ('window.periodicals' asJSObject property: self updater id)));
		add: (((PTElement new
				id: self updater id;
				call: 'basicUpdate';
				yourself) timeout: 'this.delay' asJSObject) assignTo: ('window.periodicals' asJSObject property: self updater id));
		yourself! !

PTNamed subclass: #PTArray
	instanceVariableNames: 'receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PTExtensions'!

!PTArray class methodsFor: 'public' stamp: 'ssastre@voyager 7/28/2008 15:41'!
on: aCanvas receiver: anObject
	^ (self on: aCanvas) receiver: anObject! !

!PTArray methodsFor: 'public' stamp: 'ssastre@voyager 7/28/2008 15:41'!
add: anObject

	self push: anObject! !

!PTArray methodsFor: 'public' stamp: 'ssastre@voyager 7/28/2008 15:41'!
defaultPrototype
	^ 'Array'! !

!PTArray methodsFor: 'printing' stamp: 'sebastian.sastre 3/27/2010 16:01'!
javascriptContentOn: aStream
	receiver isNil
		ifTrue:[super javascriptContentOn: aStream]
		ifFalse:[self receiver printOn: aStream]! !

!PTArray methodsFor: 'public' stamp: 'sas 12/2/2007 12:32'!
makeArguments
	"Answers new arguments meant to be a default for the receiver."
	^ Array new! !

!PTArray methodsFor: 'public' stamp: 'ssastre@voyager 7/28/2008 15:41'!
pop

	self call: 'pop'! !

!PTArray methodsFor: 'public' stamp: 'sebastian.sastre 1/25/2010 11:56'!
push: anObject

	self call: 'push' with: anObject! !

!PTArray methodsFor: 'public' stamp: 'ssastre@voyager 7/28/2008 15:41'!
receiver
	^ receiver! !

!PTArray methodsFor: 'public' stamp: 'ssastre@voyager 7/28/2008 15:41'!
receiver: anObject
	receiver := anObject! !

!PTArray methodsFor: 'public' stamp: 'ssastre@voyager 7/28/2008 15:41'!
removeLast

	self pop! !

PTNamed subclass: #PTBreak
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PTExtensions'!

!PTBreak methodsFor: 'public' stamp: 'ssastre@voyager 7/28/2008 15:41'!
printContentOn: aStream
	
	aStream nextPutAll: '$break'! !

PTNamed subclass: #PTDollarA
	instanceVariableNames: 'receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PTExtensions'!

!PTDollarA class methodsFor: 'as yet unclassified' stamp: 'sebastian.sastre 9/28/2009 05:53'!
context: aRenderConext receiver: anObject
	^ (self context: aRenderConext) receiver: anObject! !

!PTDollarA class methodsFor: 'as yet unclassified' stamp: 'sebastian.sastre 7/15/2009 16:27'!
on: aCanvas receiver: anObject
	^ (self on: aCanvas) receiver: anObject! !

!PTDollarA methodsFor: 'printing' stamp: 'sebastian.sastre 2/11/2010 14:31'!
javascriptContentOn: aStream
	receiver isNil
		ifTrue:[super javascriptContentOn: aStream]
		ifFalse:[
			aStream nextPutAll:'$A('.
			self receiver javascriptContentOn: aStream.
			aStream nextPutAll: ')']! !

!PTDollarA methodsFor: 'public' stamp: 'sebastian.sastre 7/15/2009 16:30'!
receiver
	^ receiver! !

!PTDollarA methodsFor: 'as yet unclassified' stamp: 'sebastian.sastre 7/15/2009 16:29'!
receiver: anObject
	receiver := anObject! !

!PTNamed methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:34'!
argument: anObject

	^ self arguments: (Array with: anObject)! !

!PTNamed methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:34'!
arguments
	^ arguments ifNil: [self initializeArguments]! !

!PTNamed methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:34'!
initializeArguments
	^ arguments := self makeArguments! !

!PTNamed methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:34'!
makeArguments
	"Answers new arguments meant to be a default for the receiver."
	^ Array with: self id! !

PTNamed subclass: #PTPeriodicalExecuter
	instanceVariableNames: 'receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PTExtensions'!

!PTPeriodicalExecuter class methodsFor: 'categorize me' stamp: 'sas 11/1/2008 21:38'!
on: aCanvas receiver: anObject
	^ (self on: aCanvas) receiver: anObject! !

!PTPeriodicalExecuter methodsFor: 'categorize me' stamp: 'sas 11/1/2008 21:42'!
callback: aFunction
	"Function to execute periodically."

	self callback: aFunction interval: self defaultInterval! !

!PTPeriodicalExecuter methodsFor: 'categorize me' stamp: 'sas 11/1/2008 21:42'!
callback: aFunction interval: aDuration
	"Function to execute periodically."

	self create; arguments: (Array with: aFunction with: aDuration )! !

!PTPeriodicalExecuter methodsFor: 'categorize me' stamp: 'sas 11/1/2008 21:43'!
defaultInterval

	^ 3! !

!PTPeriodicalExecuter methodsFor: 'categorize me' stamp: 'sebastian.sastre 2/17/2011 17:19'!
defaultPrototype

	^ 'PeriodicalExecuter'! !

PTNamed subclass: #PTPosition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PTExtensions'!

!PTPosition methodsFor: 'public' stamp: 'ssastre@voyager 7/28/2008 15:41'!
defaultPrototype
	^ 'Position'! !

!PTPosition methodsFor: 'public' stamp: 'ssastre@voyager 7/28/2008 15:41'!
within: anElement x: x y: y
	"Answers true if the point defined by x and y is whithin anElement."

	self 
		method: 'within';
		arguments: (Array with: anElement with: x with: y);
		yourself! !

PTNamed subclass: #PTRange
	instanceVariableNames: 'start stop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PTExtensions'!

!PTRange methodsFor: 'public' stamp: 'ssastre@voyager 7/28/2008 15:41'!
from: strt to: stp

	^ self 
		start: strt;
		stop: stp;
		enumerator ! !

!PTRange methodsFor: 'public' stamp: 'sebastian.sastre 1/17/2010 18:49'!
javascriptContentOn: aStream
	
	aStream nextPutAll: '$R(', start asJavascript, ',',stop asJavascript.
	aStream nextPutAll: ')'! !

!PTRange methodsFor: 'accessing' stamp: 'sas 1/7/2008 12:35'!
start
	"Answer the value of start"

	^ start! !

!PTRange methodsFor: 'accessing' stamp: 'sas 1/7/2008 12:35'!
start: anObject
	"Set the value of start"

	start := anObject! !

!PTRange methodsFor: 'accessing' stamp: 'sas 1/7/2008 12:35'!
stop
	"Answer the value of stop"

	^ stop! !

!PTRange methodsFor: 'accessing' stamp: 'sas 1/7/2008 12:35'!
stop: anObject
	"Set the value of stop"

	stop := anObject! !

!PTFactory methodsFor: '*ptextensions' stamp: 'sebastiansastre 1/2/2014 20:06'!
periodicalExecuter

	^ PTPeriodicalExecuter context: self! !

!PTFactory methodsFor: '*ptextensions' stamp: 'sebastiansastre 1/2/2014 20:06'!
periodicalUpdater

	^ PTPeriodicalUpdater context: self! !

!PTElement class methodsFor: '*ptextensions' stamp: 'sebastiansastre 9/28/2011 11:17'!
body

	^ self new body! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 1/25/2010 11:56'!
childOf: aDOMElement

	self call: 'childOf' with: aDOMElement ! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:53'!
extend

	self call: 'extend'! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:47'!
fire: anEventName
	"Fires anEventName custom event with the current element as its target.
	Translation: what it does is to make the receiver's DOM element to trigger
	aCustomEvent in the user agent."
	
	self fire: anEventName arguments: #()! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 1/25/2010 11:50'!
fire: anEventName arguments: someArguments
	"Fires anEventName custom event with the current element as its target.
	Translation: what it does is to make the receiver's DOM element to trigger
	aCustomEvent in the user agent.
	The event can carry optionally someArguments in the #memo property
	to allow event handlers do things with it."

	self call: 'fire' withArguments: (Array with: anEventName), someArguments! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:47'!
fire: anEventName with: anArgument

	self fire: anEventName arguments: (Array with: anArgument)! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:48'!
focus

	^ self call: 'focus'! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 1/25/2010 11:56'!
getAttribute: aString

	self call: 'getAttribute' with: aString ! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:48'!
getDimensions
	"Finds the computed width and height of element 
	and returns them (in pixels) as key/value pairs of the receiver's element."
	
	self call: 'getDimensions'! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 1/25/2010 11:57'!
hasAttribute: aString

	self call: 'hasAttribute' with: aString ! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:48'!
innerHTML
	"Get the current value 
	of the html inside the element accessed by the receiver."
	
	self access: 'innerHTML'! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:48'!
innerHTML: aString
	"Set aString for the current value 
	of the html inside the element accessed by the receiver."
	
	(self access: 'innerHTML') assign: aString! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 1/14/2010 17:45'!
insert: anObject 
	"Inserts content before, after, at the top of, or at the bottom of element, as specified by the position property of the argument. If the argument is the content itself, insert will append it to element."
	
	anObject isJavascript
		ifTrue:[self call: 'insert' with: anObject]
		ifFalse:[self call: 'insert' with: (self render: anObject)]! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 1/25/2010 11:50'!
insert: anElement position: aString 
	"Inserts content before, after, at the top of, or at the bottom of element, 
	as specified by the position property of the second argument. 
	If the second argument is the content itself, insert will append it to element."
	self 
		call: 'insert'
		withArguments: (Array 
				with: anElement
				with: (Dictionary new
						at: #position
							put: aString;
						asJSHash))! !

!PTElement methodsFor: '*ptextensions' stamp: 'SebastianSastre 1/17/2012 15:51'!
on: anEventKey call: aFunctionName in: anElement 
	self 
		on: anEventKey
		do: (anElement 
				call: aFunctionName
				with: 'anEvent' asJSObject)
! !

!PTElement methodsFor: '*ptextensions' stamp: 'SebastianSastre 1/17/2012 15:51'!
on: anEventKey call: aFunctionName with: anArgument in: anElement

	self 
		on: anEventKey 
		do: (anElement call: aFunctionName with: anArgument asJSObject)! !

!PTElement methodsFor: '*ptextensions' stamp: 'SebastianSastre 1/17/2012 15:51'!
on: anEventString do: aHandlerObject
	"Register the handler aBlock for the event aString on the receiving DOM element. Please refer to SUEvent>>#observe:on:do: for further information."

	self 
		call: 'observe' 
		withArguments: (Array 
							with: anEventString asString
							with: (aHandlerObject asFunction: #('anEvent')))! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 7/20/2009 18:50'!
parentNode
	"Answers the parent elment of the 
	element accessed by the receiver."
	
	self access: 'parentNode'! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 1/25/2010 11:57'!
select: aString
	"Takes a CSS selector and returns an enumerable of extended descendants of element that match aString."

	^ self call: 'select' with: aString; enumerator! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 1/23/2010 12:39'!
stopObserving
	"Unregister all the handler of all the events on the 
	receiving DOM element."

	^ self call: 'stopObserving' ! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 2/3/2010 09:40'!
stopObserving: anEventString
	"Unregister anEventString on the receiving DOM element.
	All handlers will stop reacting"

	^ self 
		call: 'stopObserving' 
		with: anEventString! !

!PTElement methodsFor: '*ptextensions' stamp: 'sebastian.sastre 2/3/2010 09:40'!
stopObserving: anEventString with: aHandlerObject
	"Unregister the handler aHandlerObject for anEventString on the 
	receiving DOM element. 
	Note that aHandlerObject must be the exact instance which 
	registered the event to stop observing properly."

	^ self 
		call: 'stopObserving' 
		withArguments: (Array with: anEventString with: aHandlerObject)! !
